import randomGenerator from './RandomGenerator'
import { Country } from '../../Enum/Country'
import { Gender } from '../../Enum/Gender'
import { Person } from '@/classes/DTO/Person'

export class PersonalIdGenerator {
  /**
   * @param person
   */
  generate (person: Person) {
    const fullYear = this.grabFullYear(person.birthday.year)
    const year = this.getYearPart(fullYear)
    const month = this.getMonthPart(person.birthday.month)
    const day = this.getDayPart(person.birthday.day)
    const o = this.getIdNumPart()
    const a = this.getGenderPart(person.country, person.gender, fullYear)
    const l = this.getControlSum(person.country, year, month, day, o, a)
    const l2 = this.getChecksum(a + year + month + day + o)

    return a + year + month + day + o + l2
  }

  grabFullYear (year: bigint | null): bigint {
    if (!year) {
      const e = (new Date()).getFullYear()
      year = BigInt(randomGenerator.generate(e - 25, e - 55))
    }
    return year
  }

  /**
   * e.getYearPart = function () {
    var e = (new Date).getFullYear();
    return String(Iu.generate(e - 25, e - 55)).substring(2, 4)
  },
   */
  getYearPart (year: bigint) {
    return String(year).substring(2, 4)
  }

  /**
   *  e.getMonthPart = function () {
    return Iu.generate(1, 12).toString().padStart(2, "0")
  },
   */
  getMonthPart (month: bigint | null) {
    if (!month) {
      month = BigInt(randomGenerator.generate(1, 12))
    }
    return month.toString().padStart(2, '0')
  }

  /**
   *  e.getDayPart = function () {
    return Iu.generate(1, 28).toString().padStart(2, "0")
  },
   */
  getDayPart (day: bigint | null) {
    if (!day) {
      day = BigInt(randomGenerator.generate(1, 28))
    }
    return day.toString().padStart(2, '0')
  }

  /**
   * e.getIdNumPart = function () {
    return Iu.generate(1, 999).toString().padStart(3, "0")
  },
   */
  getIdNumPart () {
    return randomGenerator.generate(1, 999).toString().padStart(3, '0')
  }

  /**
   *  e.getGenderPart = function (e, t) {
    switch (e) {
      case"pl":
        "male" === t ? t = String(2 * Iu.generate(1, 5) - 1) : "female" === t && (t = String(2 * Iu.generate(1, 4)));
        break;
      default:
        "male" === t ? t = "3" : "female" === t && (t = "4")
    }
    return t
  },
   * @param country
   * @param gender
   * @param year
   */
  getGenderPart (country: Country, gender: Gender, year: bigint) {
    console.log(country, gender)
    let tempGender = gender
    switch (country) {
      case Country.POLAND:
        console.log(country)
        return Gender.MALE === gender
          ? String(2 * randomGenerator.generate(1, 5) - 1)
          : String(2 * randomGenerator.generate(1, 4))
      default:
        console.log(gender, Gender.MALE === gender)
        if (Gender.RANDOM === gender) {
          tempGender = randomGenerator.generate(1, 999) > 500 ? Gender.FEMALE : Gender.MALE
        }
        console.log(year, 'year', typeof year)
        return Gender.MALE === tempGender ? (year < 2000 ? '3' : '5') : (year < 2000 ? '4' : '6')
    }
  }

  /**
   * public static function getChecksum($personalId)
   {
    $s1 = $s2 = 0;
    $k1 = 1;
    $k2 = 3;

    for ($i = 0; $i < strlen($personalId) - 1; $i++) {
      $s1 += $personalId[$i] * $k1;
      $s2 += $personalId[$i] * $k2;
      $k1 = ($k1 == 9) ? 1 : $k1 + 1;
      $k2 = ($k2 == 9) ? 1 : $k2 + 1;
    }
    $checksum = 0;
    if (($s1 % 11) < 10) {
      $checksum = $s1 % 11;
    } elseif (($s2 % 11) < 10) {
      $checksum = $s2 % 11;
    }

    return $checksum;
  }
   *
   *
   * e.getControlSum = function (e, t, n, r, i, o) {
    var a, l;
    if ("pl" === e) return l = +(a = t + n + r + i + o)[0] + 3 * +a[1] + 7 * +a[2] + 9 * +a[3] + +a[4] + 3 * +a[5] + 7 * +a[6] + 9 * +a[7] + +a[8] + 3 * +a[9], 0 != (l %= 10) && (l = 10 - l), String(l);
    a = o + t + n + r + i;
    for (var s = 1, u = 3, c = 0, d = 0, h = 0; h < 10; h++) {
      var p = +a[h];
      c += p * s, d += p * u, 10 == ++s && (s = 1), 10 == ++u && (u = 1)
    }
    return d %= 11, (c %= 11) < 10 ? String(c) : d < 10 ? String(d) : String(0)
  }
   * @param e
   * @param t
   * @param n
   * @param r
   * @param i
   * @param o
   */
  getControlSum (e: Country, t: string, n: string, r: string, i: string, o: string) {
    let a
    let l
    if (Country.POLAND === e) {
      l = +(a = t + n + r + i + o)[0] + 3 * +a[1] + 7 * +a[2] + 9 * +a[3] + +a[4] + 3 * +a[5] + 7 * +a[6] + 9 * +a[7] + +a[8] + 3 * +a[9];
      (l %= 10) !== 0 && (l = 10 - l)
      l = String(l)

      return l
    }

    let c = 0
    let d = 0
    a = o + t + n + r + i
    for (let s = 1, u = 3, c = 0, d = 0, h = 0; h < 10; h++) {
      const p = +a[h]
      c += p * s
      d += p * u
      ++s === 10 && (s = 1)
      ++u === 10 && (u = 1)
    }
    d %= 11
    return (c %= 11) < 10 ? String(c) : d < 10 ? String(d) : String(0)
  }

  getChecksum (code: string) {
    let b = 1
    let c = 3
    let d = 0
    let e = 0
    let i
    let digit
    for (i = 0; i < 10; i++) {
      digit = parseInt(code[i])
      d += digit * b
      e += digit * c
      b++; if (b === 10) b = 1
      c++; if (c === 10) c = 1
    }
    d = d % 11
    e = e % 11
    if (d < 10) {
      return d
    } else if (e < 10) {
      return e
    }

    return 0
  }

  // getChecksum($personalId)
  // {
  //   $s1 = $s2 = 0;
  //   $k1 = 1;
  //   $k2 = 3;
  //
  //   for ($i = 0; $i < strlen($personalId) - 1; $i++) {
  //     $s1 += $personalId[$i] * $k1;
  //     $s2 += $personalId[$i] * $k2;
  //     $k1 = ($k1 == 9) ? 1 : $k1 + 1;
  //     $k2 = ($k2 == 9) ? 1 : $k2 + 1;
  //   }
  //   $checksum = 0;
  //   if (($s1 % 11) < 10) {
  //     $checksum = $s1 % 11;
  //   } elseif (($s2 % 11) < 10) {
  //     $checksum = $s2 % 11;
  //   }
  //
  //   return $checksum;
  // }
}

export default new PersonalIdGenerator()
